;
; PDA C Startup module
;
; note: Can't have usual BSS section because there's only 2K of SRAM
; and the area after the program is supposed to be ROM
; Stack will presumably be in the SRAM so local variables are OK.
;
; So, lets just initialise the stack pointer.
;
; Need to discuss start-up with someone that knows.
; Entry Point is useless but by putting this first we can
; just load it as a binary and jump to the start.
;
	opt	c+	;must be case sensitive

	section	.text
	section	.ctors
	section	.dtors
	section	.rdata
	section	.data
	section	.sdata
	section	.sbss
	section	.bss

	xdef	__SN_ENTRY_POINT
	xdef	__gccmain
	xdef	myputch
	xref	main

SRAMbase	equ	$01000000	;start of SRAM (in second area)
SRAMsize	equ	$800

	section	.text
	code32

	dcb	"SN"
	dcb	0,0

__SN_ENTRY_POINT
	ldr	r1,=(SRAMbase+SRAMsize-64)
	mov	sp,r1

	stmfd	sp!,{r0,lr}	;save r0 & link register
	bl	main	;branch and link user code
armcode	ldmfd	sp!,{r0,lr}	;restore r0 & link register

	mov	pc,lr	;return

;
; ARM mode dummy __gccmain called from main to init BSS
;
__gccmain	mov	pc,lr	;dummy init bss routine

	ltorg

;
; Here is our putch() routine. The special undefined instruction causes
; a trap to the emulator app so it can print the characters
; note that since C program is all in ARM mode this routine must
; also be entered in ARM mode.
;
myputch	dcd	$E6000010
	mov	pc,lr

	end

